/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   assign_stmt.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_ASSIGN_STMT_H
#define UHDM_ASSIGN_STMT_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/atomic_stmt.h>




namespace UHDM {
class expr;

class assign_stmt final : public atomic_stmt {
  UHDM_IMPLEMENT_RTTI(assign_stmt, atomic_stmt)
public:
  // Implicit constructor used to initialize all members,
  // comment: assign_stmt();
  virtual ~assign_stmt() final = default;

  expr* Rhs()  { return rhs_; }
  const expr* Rhs() const { return rhs_; }
  template <typename T>
  T* Rhs() {
    return (rhs_ == nullptr) ? nullptr : any_cast<T*>(rhs_);
  }
  template <typename T>
  const T* Rhs() const {
    return (rhs_ == nullptr) ? nullptr : any_cast<const T*>(rhs_);
  }
  bool Rhs(expr* data) {
    rhs_ = data;
    return true;
  }

  expr* Lhs()  { return lhs_; }
  const expr* Lhs() const { return lhs_; }
  template <typename T>
  T* Lhs() {
    return (lhs_ == nullptr) ? nullptr : any_cast<T*>(lhs_);
  }
  template <typename T>
  const T* Lhs() const {
    return (lhs_ == nullptr) ? nullptr : any_cast<const T*>(lhs_);
  }
  bool Lhs(expr* data) {
    lhs_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiAssignStmt; }

  virtual assign_stmt* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmassign_stmt; }

protected:
  void DeepCopy(assign_stmt* clone, BaseClass* parent, CloneContext* context) const;

private:
  expr* rhs_ = nullptr;

  expr* lhs_ = nullptr;
};


typedef FactoryT<assign_stmt> assign_stmtFactory;


typedef FactoryT<std::vector<assign_stmt *>> VectorOfassign_stmtFactory;

}  // namespace UHDM

#endif
