/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   func_call.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_FUNC_CALL_H
#define UHDM_FUNC_CALL_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/tf_call.h>




namespace UHDM {
class function;

class func_call final : public tf_call {
  UHDM_IMPLEMENT_RTTI(func_call, tf_call)
public:
  // Implicit constructor used to initialize all members,
  // comment: func_call();
  virtual ~func_call() final = default;

  int32_t VpiFuncType() const { return vpiFuncType_; }
  bool VpiFuncType(int32_t data) {
    vpiFuncType_ = data;
    return true;
  }

  function* Function()  { return function_; }
  const function* Function() const { return function_; }
  template <typename T>
  T* Function() {
    return (function_ == nullptr) ? nullptr : any_cast<T*>(function_);
  }
  template <typename T>
  const T* Function() const {
    return (function_ == nullptr) ? nullptr : any_cast<const T*>(function_);
  }
  bool Function(function* data) {
    function_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiFuncCall; }

  virtual tf_call* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmfunc_call; }

protected:
  void DeepCopy(func_call* clone, BaseClass* parent, CloneContext* context) const;

private:
  int32_t vpiFuncType_ = 0;

  function* function_ = nullptr;
};


typedef FactoryT<func_call> func_callFactory;


typedef FactoryT<std::vector<func_call *>> VectorOffunc_callFactory;

}  // namespace UHDM

#endif
