/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   sequence_decl.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_SEQUENCE_DECL_H
#define UHDM_SEQUENCE_DECL_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/BaseClass.h>

#include "sequence_expr_multiclock_group.h"


namespace UHDM {


class sequence_decl final : public BaseClass {
  UHDM_IMPLEMENT_RTTI(sequence_decl, BaseClass)
public:
  // Implicit constructor used to initialize all members,
  // comment: sequence_decl();
  virtual ~sequence_decl() final = default;

  virtual bool VpiName(std::string_view data) final;
  virtual std::string_view VpiName() const final;

  bool VpiFullName(std::string_view data);
  std::string_view VpiFullName() const;

  VectorOfattribute* Attributes() const { return attributes_; }
  bool Attributes(VectorOfattribute* data) {
    attributes_ = data;
    return true;
  }

  VectorOfvariables* Variables() const { return variables_; }
  bool Variables(VectorOfvariables* data) {
    variables_ = data;
    return true;
  }

  any* Sequence_expr_multiclock_group()  { return sequence_expr_multiclock_group_; }
  const any* Sequence_expr_multiclock_group() const { return sequence_expr_multiclock_group_; }
  template <typename T>
  T* Sequence_expr_multiclock_group() {
    return (sequence_expr_multiclock_group_ == nullptr) ? nullptr : any_cast<T*>(sequence_expr_multiclock_group_);
  }
  template <typename T>
  const T* Sequence_expr_multiclock_group() const {
    return (sequence_expr_multiclock_group_ == nullptr) ? nullptr : any_cast<const T*>(sequence_expr_multiclock_group_);
  }
  bool Sequence_expr_multiclock_group(any* data) {
    if (!sequence_expr_multiclock_groupGroupCompliant(data)) return false;
    sequence_expr_multiclock_group_ = data;
    return true;
  }

  VectorOfseq_formal_decl* Seq_formal_decls() const { return seq_formal_decls_; }
  bool Seq_formal_decls(VectorOfseq_formal_decl* data) {
    seq_formal_decls_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiSequenceDecl; }

  virtual sequence_decl* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmsequence_decl; }

protected:
  void DeepCopy(sequence_decl* clone, BaseClass* parent, CloneContext* context) const;

private:
  SymbolId vpiName_;

  SymbolId vpiFullName_;

  VectorOfattribute* attributes_ = nullptr;

  VectorOfvariables* variables_ = nullptr;

  any* sequence_expr_multiclock_group_ = nullptr;

  VectorOfseq_formal_decl* seq_formal_decls_ = nullptr;
};


typedef FactoryT<sequence_decl> sequence_declFactory;


typedef FactoryT<std::vector<sequence_decl *>> VectorOfsequence_declFactory;

}  // namespace UHDM

#endif
