/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   table_entry.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_TABLE_ENTRY_H
#define UHDM_TABLE_ENTRY_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/BaseClass.h>




namespace UHDM {


class table_entry final : public BaseClass {
  UHDM_IMPLEMENT_RTTI(table_entry, BaseClass)
public:
  // Implicit constructor used to initialize all members,
  // comment: table_entry();
  virtual ~table_entry() final = default;

  int32_t VpiSize() const { return vpiSize_; }
  bool VpiSize(int32_t data) {
    vpiSize_ = data;
    return true;
  }

  bool VpiValue(std::string_view data);
  std::string_view VpiValue() const;

  VectorOfattribute* Attributes() const { return attributes_; }
  bool Attributes(VectorOfattribute* data) {
    attributes_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiTableEntry; }

  virtual table_entry* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmtable_entry; }

protected:
  void DeepCopy(table_entry* clone, BaseClass* parent, CloneContext* context) const;

private:
  int32_t vpiSize_ = 0;

  SymbolId vpiValue_;

  VectorOfattribute* attributes_ = nullptr;
};


typedef FactoryT<table_entry> table_entryFactory;


typedef FactoryT<std::vector<table_entry *>> VectorOftable_entryFactory;

}  // namespace UHDM

#endif
